<?php
/*
* 2007-2015 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2015 PrestaShop SA
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

if (!defined('_PS_VERSION_'))
	exit;

class ecm_blockuserinfo extends Module
{
	private $_html = '';

	public function __construct()
	{
		$this->name = 'ecm_blockuserinfo';
		$this->tab = 'front_office_features';
		$this->version = '0.0.1';
		$this->author = 'Elcommerce';
		$this->need_instance = 1;
		$this->bootstrap = true;

		parent::__construct();

		$this->displayName = $this->l('User info block');
		$this->description = $this->l('Adds a block with authentication form in modal window.');
		$this->ps_versions_compliancy = array('min' => '1.6', 'max' => _PS_VERSION_);
	}

	public function install()
	{
		return (parent::install() && $this->registerHook('displayTop') && $this->registerHook('displayNav') && $this->registerHook('displayHeader'));
	}
	 static function remove_doublewhitespace($s = null){
           return  $ret = preg_replace('/([\s])\1+/', ' ', $s);
    }

    static function remove_whitespace($s = null){
           $ret = preg_replace('/[\s]+/', '', $s );
           $ret = mysql_escape_string($ret);
           return $ret;
    }

    static function remove_whitespace_feed( $s = null){
           return $ret = preg_replace('/[\t\n\r\0\x0B]/', ' ', $s);
    }

    static function smart_clean($s = null){
           return $ret = trim( self::remove_doublewhitespace( self::remove_whitespace_feed($s) ) );
    }

	/**
	* Returns module content for header
	*
	* @param array $params Parameters
	* @return string Content
	*/
	/*public function hookDisplayTop($params)
	{
		if (!$this->active)
			return;

		$this->smarty->assign(array(
			'cart' => $this->context->cart,
			'cart_qties' => $this->context->cart->nbProducts(),
			'logged' => $this->context->customer->isLogged(),
			'customerName' => ($this->context->customer->logged ? $this->context->customer->firstname.' '.$this->context->customer->lastname : false),
			'firstName' => ($this->context->customer->logged ? $this->context->customer->firstname : false),
			'lastName' => ($this->context->customer->logged ? $this->context->customer->lastname : false),
			'order_process' => Configuration::get('PS_ORDER_PROCESS_TYPE') ? 'order-opc' : 'order'
		));
		return $this->display(__FILE__, 'ecm_blockuserinfo.tpl');
	}*/

	public function hookDisplayHeader($params)
	{
		$this->context->controller->addCSS(($this->_path).'ecm_blockuserinfo.css', 'all');
	}

	public function hookDisplayNav($params)
	{
		$arr = array("<p>","</p>");
		$ulogin = str_replace($arr,'',Configuration::get('ulogin_widget'));
		$this->smarty->assign(array(

			'ulogin' => html_entity_decode($ulogin),

		));
		return $this->display(__FILE__, 'nav.tpl');
	}
	public function getContent()
	{
		if (Tools::isSubmit('submitbmw'))
		{
		$this->postProcess();
		}
		if (Tools::isSubmit('submitbmw1'))
		{
		$this->postProcess1();
		}
		$this->_html .= $this->renderForm();
		$this->_displayabout();
		return $this->_html;

	}
	public function renderForm()
	{
		//$arr = array("<p>","</p>");
		//$ulogin = str_replace($arr,'',html_entity_decode(Configuration::get('ulogin_widget')));
		//d($ulogin);
			$this->fields_form[0]['form'] = array(
				'legend' => array(
				'title' => $this->l('Settings'),
				'icon' => 'icon-cog'

			),
			'input' => array(
				array(
					'type' => 'switch',
					'label' => $this->l('Ulogin compability'),
					'desc' => $this->l('Check to display Ulogin widjet in modal authentication widget'),
					'name' => 'ulogin',
					'values' => array(
						array(
							'id' => 'ulogin_on',
							'value' => 1,
							'label' => $this->l('Enabled')
						),
						array(
							'id' => 'ulogin_off',
							'value' => 0,
							'label' => $this->l('Disabled')
						)
					)
				),

			),

			'submit' => array(
				'name' => 'submitbmw',
				'title' => $this->l('Save')
			)
		);
		if(Configuration::get('ulogin') == 1)
		$this->fields_form[1]['form'] = array(
				'tinymce' => true,
				'legend' => array(
				'title' => $this->l('Ulogin widget sourse code'),
				'icon' => 'icon-code'

			),
			'input' => array(

				array(
					'type' => 'textarea',
					'label' => $this->l('Sourse code ulogin widget'),
					'rows' => 5,
					'autoload_rte' => true,
					'desc' => $this->l('Enter the sourse code ulogin widget on a manual'),
					'name' => 'ulogin_widget',
				),
			),

			'submit' => array(
				'name' => 'submitbmw1',
				'title' => $this->l('Save')
			)
		);

		$helper = new HelperForm();
		$helper->module = $this;
		$helper->show_toolbar = false;
		//$helper->table = $this->table;
		$lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
		$helper->default_form_language = $lang->id;
		$helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
		$helper->identifier = $this->identifier;
		$helper->submit_action = 'submitbmw';
		$helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.
			'&tab_module='.$this->tab.'&module_name='.$this->name;
		$helper->token = Tools::getAdminTokenLite('AdminModules');
		$helper->tpl_vars = array(
			'fields_value' => $this->getConfigFieldsValues(),
			'languages' => $this->context->controller->getLanguages(),
			'id_language' => $this->context->language->id
		);
		return $helper->generateForm($this->fields_form);
	}
	private function postProcess()
	{
		//d(_PS_THEME_DIR_);
		if (Tools::getValue('ulogin') == 0)
		{
		Configuration::deleteByName('ulogin_widget');
		@unlink(_PS_THEME_DIR_.'modules/ulogin/nav.tpl');
		}else{
		@mkdir(_PS_THEME_DIR_.'modules/ulogin', 0755, true);
		@file_put_contents(_PS_THEME_DIR_.'modules/ulogin/nav.tpl', '');
		}
		Configuration::updateValue('ulogin', Tools::getValue('ulogin'));
		$this->_html .= $this->displayConfirmation($this->l('Settings updated.'));
	}
	private function postProcess1()
	{
		$v=trim($_POST['ulogin_widget']);
        //$v=self::smart_clean($v);
        $body=$v;
		Configuration::updateValue('ulogin_widget',  $body, true);
		$this->_html .= $this->displayConfirmation($this->l('Settings updated.'));
	}
	public function getConfigFieldsValues()
	{
		$fields_values = array();
		$languages = Language::getLanguages(false);
		$fields_values['ulogin'] = Configuration::get('ulogin');
		$fields_values['ulogin_widget'] = Configuration::get('ulogin_widget');
		//$fields_values['p24_postvalidate'] = Configuration::get('p24_postvalidate');
		//$fields_values['p24_delivery'] = Configuration::get('p24_delivery');
		return $fields_values;
	}

	private
	function _displayabout(){
		$this->_html .= '
		<div class="panel">
		<div class="panel-heading">
			<i class="icon-envelope"></i> ' . $this->l('Информация') . '
		</div>
		<div id="dev_div">
		<span><b>' . $this->l('Версия') . ':</b> ' . $this->version . '</span><br>
		<span><b>' . $this->l('Разработчик') . ':</b> <a class="link" href="mailto:support@elcommerce.com.ua" target="_blank">УElcommerce</a>

		<span><b>' . $this->l('Описание') . ':</b> <a class="link" href="http://elcommerce.com.ua" target="_blank">http://elcommerce.com.ua</a><br><br>
		<p style="text-align:center"><a href="http://elcommerce.com.ua/"><img src="http://elcommerce.com.ua/img/m/logo.png" alt="Электронный учет коммерческой деятельности" /></a>

		</div>
		</div>
		';
	}
}
